//----------------------------------------------------------------------------------------
// Author: Stanislav.Shilo (shilo.stanislav.dmitrievich@gmail.com, skype: stanislav.shilo)
//----------------------------------------------------------------------------------------
var tab_url;
var similarsites_main = 
{
	products : new Array(),
	renderHistoryList: function() 
	{
		try 
		{
            window.frames["SimilarSitesIfr"].location.reload();
		} 
		catch(e) 
		{
			return null;
		}
	},
	
    init: function()
	{
		var is_removed = 0;
		var show_button = true;
		try{
			is_removed = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getCharPref("similarsites.buttonremoved");
		}
		catch(e){}
		try{
			show_button = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getBoolPref("similarsites.show_button");
		}
		catch(e){
			show_button = (is_removed !="1");
		}
	
		try{
			Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").setBoolPref("similarsites.show_button",show_button);
		}
		catch(e){
		}

		
		var enable_sf = true;
		try{
			enable_sf = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getBoolPref("similarsites.enable_sf");
		}
		catch(e){
		}
		
		if ( enable_sf )
		{
			similarsites_main.load_sf_domains();
		}


		try{
			Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").setBoolPref("similarsites.enable_sf",enable_sf);
		}
		catch(e){
		}
	
	
	    var navBar  = document.getElementById("nav-bar");
		if ( navBar.currentSet.indexOf("similarsites-add-list-button") == -1 )
		{
			if ( show_button != false)
				navBar.currentSet += ",similarsites-add-list-button"
		}
		else if ( !show_button )
		{
			navBar.currentSet.replace("similarsites-add-list-button","");
		}
		
    },
    load_sf_domains : function()
	{
		var local_file = "";
		try 
		{
			local_file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		}
		catch (E) {
			return null;
		};

		local_file.append("SimilarProducts.json");
		var cur_time = (new Date()).getTime();
		var last_update = 0;
		if ( !local_file.exists() || ( (cur_time - local_file.lastModifiedTime ) > 86400000))
		{
			try{		local_file.remove(false);} catch(e){};
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				try{
					if ((req.readyState == 4) && (req.status == 200 || req.status == 0))
					{
						var tmp_json = JSON.parse(req.responseText.substring(req.responseText.indexOf("(")+1,req.responseText.lastIndexOf(")")));
						var tmp_res = JSON.stringify(tmp_json);
						var local_file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
						local_file.append("SimilarProducts.json");
						local_file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
						var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );
						outputStream.init( local_file, 0x04 | 0x08 | 0x20, 420, 0 );
						var result = outputStream.write( tmp_res, tmp_res.length );
						outputStream.close();
						similarsites_main.load_sf_domains();
					}
				}
				catch(e){
				}
			}
			req.open("GET", "https://www.superfish.com/ws/getSupportedSitesJSON.action?dlsource=similarweb", true);
			try{req.send(null);}
			catch (e){}
			//download the file and reload
			//
			return;
		}
		var fn = "file:///"+local_file.path;
		var req = new XMLHttpRequest();
		req.onreadystatechange = function()
		{
			try
			{
				if (req.readyState == 4)
				{
					if (req.status == 200 || req.status == 0)
					{
						try{
							 var tmp = JSON.parse(req.responseText);
							 similarsites_main.products = new Array();
							 var site = "";
							 for (site in tmp.supportedSitesMap) 
							 {
								similarsites_main.products.push(site);
							 }
						}
						catch(e)
						{
							similarsites_main.products = new Array();
						}
					}
					
				}
			}
			catch (E)
			{
			}
			
			
		};
		req.open("GET", fn, true);
		try{req.send(null);}
		catch (e){}
		
			//file.initWithPath('C:\\temp\\temp.txt');
			var charset = 'UTF-8';
			var fileStream = Components.classes['@mozilla.org/network/file-input-stream;1']
							 .createInstance(Components.interfaces.nsIFileInputStream);
			fileStream.init(local_file, 1, 0, false);
			var converterStream = Components.classes['@mozilla.org/intl/converter-input-stream;1']
								  .createInstance(Components.interfaces.nsIConverterInputStream);
								  converterStream.init(fileStream, charset, fileStream.available(),
								  converterStream.DEFAULT_REPLACEMENT_CHARACTER);
			var out = {};
			converterStream.readString(fileStream.available(), out);
			var fileContents = out.value;
			converterStream.close();
			fileStream.close();
			var tmp = JSON.parse(fileContents);
			similarsites_main.products = new Array();
			var site = '';
			for (site in tmp.supportedSitesMap) 
			{
				similarsites_main.products.push(site);
			}
			
	},
    destroy: function()
	{
	    var navBar  = document.getElementById("nav-bar");
		if ( navBar.currentSet.indexOf("similarsites-add-list-button") == -1 )
			Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").setCharPref("similarsites.buttonremoved","1");
    },
    
    currentURL: function()
	{
    },
};

var similar_sites_popup = {
	clear : function()
	{
		document.getElementById("similarsites-dropdown").removeChild(document.getElementById("SimilarSitesIfr"))
		var ifr = document.createElement("iframe");
		ifr.setAttribute('src', 'chrome://similarsites/content/popup.html');
		ifr.style.width = "570px";
		ifr.style.height = "530px";
		ifr.id = "SimilarSitesIfr";
		document.getElementById("similarsites-dropdown").appendChild(ifr);
	}
}

window.addEventListener("load", function() { similarsites_main.init(); }, false); 
window.addEventListener("unload", function(){ similarsites_main.destroy(); }, false);
